import operator
import sys

files = (
    #r'D:\data\bugs\896058 mem\reco01.log',
    r'D:\data\bugs\896058 mem\reco04.log',
    #r'D:\data\bugs\896058 mem\mem1.log',
    #'clear.txt',
    #'script_result.txt',
    #r'D:\data\bugs\logs\mem.txt',
    )
def mem_sum(file):
    text = ''
    with open(file, 'r', encoding='utf8') as f:
        text = f.read()
    pos = 0
    mem = 0
    blo = {}
    while pos != -1:
        old = pos
        pos = text.find('bytes long.', pos + 1)
        beg = text.find(',', pos - 20)+1
        if beg != -1 and (pos - beg) > 0:
            try:
                num = int(text[beg : pos])
                #print(beg, pos, num)
                mem += num
                if blo.get(num, 0) == 0:
                    blo[num] = 0
                blo[num] += 1
            except Exception as e:
                print(e)
                pass
    return mem, blo

MAX_COUNT = 10
for file in files:
    byte, blo = mem_sum(file)
    mbyte = byte / 1024 / 1024
    s = file.split('.')[0]
    if s.find('выходе') == -1:
        s += ' запуске'
    print('\n', 'Утечки ' + s + ':', byte, 'bytes,', mbyte, 'Mib')
    leaks = sorted(blo.items(), key=operator.itemgetter(0), reverse=True)
    ttt = ''
    if len(leaks) > MAX_COUNT:
        ttt = '...'
    sum2 = 0
    i = 0
    for leak in leaks:
        if i >= MAX_COUNT:
            break
        sum2 += leak[0] * leak[1]
        s = ''
        m = leak[0]
        if leak[1] > 1:
            m = leak[0] * leak[1]
            s = str(m)
        sys.stdout.write(str(leak) + s + ', ' + str(int(m / byte * 100)) + '% ') 
        i += 1
    print(ttt)
    print('показано', sum2 / byte * 100, '% памяти')
            
